#!/usr/bin/env python

###
### This file is generated automatically by SALOME v9.14.0 with dump python functionality
###

import sys
import salome

salome.salome_init()
import salome_notebook
notebook = salome_notebook.NoteBook()
sys.path.insert(0, r'/volatile/catA/cb235102/PROJETS/CFD/from-franco-torus')

###
### GEOM component
###

import GEOM
from salome.geom import geomBuilder
import math
import SALOMEDS


geompy = geomBuilder.New()

O = geompy.MakeVertex(0, 0, 0)
OX = geompy.MakeVectorDXDYDZ(1, 0, 0)
OY = geompy.MakeVectorDXDYDZ(0, 1, 0)
OZ = geompy.MakeVectorDXDYDZ(0, 0, 1)
entity_19_brep_1 = geompy.ImportBREP("entity_19.brep" )
wire_19_brep_1 = geompy.ImportBREP("wire_19.brep" )

geompy.addToStudy( O, 'O' )
geompy.addToStudy( OX, 'OX' )
geompy.addToStudy( OY, 'OY' )
geompy.addToStudy( OZ, 'OZ' )
geompy.addToStudy( entity_19_brep_1, 'entity_19.brep_1' )
geompy.addToStudy( wire_19_brep_1, 'wire_19.brep_1' )

# call MakeFaceFromSurface several times and check the area
for i in range(20):
  Face_1 = geompy.MakeFaceFromSurface(entity_19_brep_1, wire_19_brep_1)
  area = geompy.BasicProperties(Face_1)[1]
  geompy.addToStudy(Face_1, f"Face_{i}_{area}")

# change orientation of edges so that they define a closed contour with coherent orientation
p_start = geompy.SubShapeAll(wire_19_brep_1, geompy.ShapeType["VERTEX"])[0]
edges = geompy.GetSubShapeEdgeSorted(wire_19_brep_1, p_start)
geompy.addToStudy(edges[0], "edge_0")
for i in range(len(edges)-1):
  edge = edges[i]
  p1 = geompy.MakeVertexOnCurve(edge, 0, takeOrientationIntoAccount=False)
  p2 = geompy.MakeVertexOnCurve(edge, 1, takeOrientationIntoAccount=False)
  geompy.addToStudy(p1, "p1")
  geompy.addToStudy(p2, "p2")
  next_edge = edges[i+1]
  p3 = geompy.MakeVertexOnCurve(next_edge, 0, takeOrientationIntoAccount=False)
  p4 = geompy.MakeVertexOnCurve(next_edge, 1, takeOrientationIntoAccount=False)
  geompy.addToStudy(p3, "p3")
  geompy.addToStudy(p4, "p4")
  name = "edge_"+str(i+1)
  if geompy.MinDistance(p2, p3) > 1e-7:
    next_edge = geompy.ChangeOrientationShellCopy(next_edge)
    name+="_changed"
    edges[i+1] = next_edge
  geompy.addToStudy(next_edge, name)

# call MakeFaceFromSurface several times on the reoriented wire
Wire_reoriented = geompy.MakeWire(edges, theName="Wire_reoriented")
for i in range(20):
  Face_1 = geompy.MakeFaceFromSurface(entity_19_brep_1, Wire_reoriented)
  area = geompy.BasicProperties(Face_1)[1]
  geompy.addToStudy(Face_1, f"Face_{i}_{area}")

# change orientation of the whole wire
Wire_reoriented_reversed = geompy.ChangeOrientationShellCopy(Wire_reoriented, theName="Wire_reoriented_reversed")
for i in range(20):
  Face_1 = geompy.MakeFaceFromSurface(entity_19_brep_1, Wire_reoriented_reversed)
  area = geompy.BasicProperties(Face_1)[1]
  geompy.addToStudy(Face_1, f"Face_{i}_{area}")

if salome.sg.hasDesktop():
  salome.sg.updateObjBrowser()
